(*****************************************************************************)
(*                                                                           *)
(*            PICSPC - Pascal Integrated Communications System               *)
(*                                                                           *)
(*                       Copyright (c) 1986, 1987                            *)
(*                          by  Les Archambault                              *)
(*                                                                           *)
(*                   All commercial rights reserved.                         *)
(*                                                                           *)
(*    This program is based on ROS Vers 3.4 by Steve Fox. It is released     *)
(*    into the public domain for private use only. Additional thanks to:     *)
(*    Irv Hoff whose 1k protocal in KMD was invaluable in writing the        *)
(*    Turbo Pascal routines. The authors of DEARC for the basic code that    *)
(*    deals with Arc files. The author of ASYNC.ARC for the code to make     *)
(*    possible the interupt service routines.                                *)
(*    Special thanks to Lindsay Jones, Eric Daniel, Freeman Bradford and     *)
(*    John Van Hengel for beta testing and support.                          *)
(*                                                                           *)
(*****************************************************************************)

{For update & modification history see the file PPCUPD.HIS.}

program PICSPC;
{$C-}

const
  version = 'PICS-PC v5.0';
  ver_date = '6/20/87';

{$I PPCDEF.INC}     {SYSTEM DEFAULTS}
{$I PPCVAR.INC}     {System Types and Variables}

  { Turbo Toolbox }
{$I ACCESS3.BOX}
{$I GETKEY.BOX}

var
  DatF: DataFile;
  IdxF: IndexFile;

  { Machine dependent code }
{$I PPCMCH.INC }                           { Computer and channel routines }
{$I PPCMDM.INC}                           { Modem routines }

  { System kernel }
{$I PPCKIO.INC}                             { I/O drivers - resident    }
{$I PPCKMS.INC}                             { Resident & .000 overlays  }
{$I PPC0A.INC}                            { Overlays for .001 file    }
{$I PPC0B.INC}                            {      "              "     }
{$I PPC0C.INC}                            {      "              "     }
{$I PPC0D.INC}                            {      "              "     }
{$I PPC0E.INC}                            {      "              "     }
{$I PPC0F.INC}                            {      "              "     }
{$I PPC0G.INC}                            {      "              "     }

  { Turbo Toolbox   NOTE: THESE ROUTINES SHOULD BE MADE INTO OVERLAYS   }
{$I ADDKEY.BOX}
{$I DELKEY.BOX}
{$I PPC0H.INC}                            { mesg. overlays .002 file  }
{$I PPC0I.INC}                            {      "              "     }

  { Force a new overlay }
type dummy = char;

{$I PPC2A.INC}                            { Overlays for  .003 file   }
{$I PPC2B.INC}                            {       "            "      }
{$I PPC2C.INC}                            {       "            "      }
{$I PPC2D.INC}                            {       "            "      }
{$I PPC2E.INC}                            {       "            "      }
{$I PPC2F.INC}                            {       "            "      }
{$I PPC2G.INC}                            {       "            "      }
{$I PPC2H.INC}                            {       "            "      }
{$I PPC2I.INC}                            {       "            "      }
{$I PPC2J.INC}                            {       "            "      }
{$I PPC2K.INC}                            {       "            "      }
{$I PPC2L.INC}                            {       "            "      }

{$I PPCMAIN.INC}

{End of PICSPC.PAS}
